﻿var CANVAS_WIDTH = 0;
var CANVAS_HEIGHT = 0;

var PAN_WIDTH_SMALL = 3;
var PAN_WIDTH_NORMAL = 5;
var PAN_WIDTH_BIG = 8;

var MAX_VELOCITY = 10;
var context = null;
var HAS_IMAGE = false;
var scale = 1;


var mCanvasWidth = 0;
var mCanvasHeight = 0;
var mCanvasOffsetLeft = 0;
var mCanvasOffsetTop = 0;

var base_url = null;
var token = null;

var mStartPoint = {
    x: 0,
    y: 0
}

var mEndPoint = {
    x: 0,
    y: 0
}


var mPanWidth = PAN_WIDTH_NORMAL;
var canvas2;
var context2;


var mEffectivePoint = {
    minX: -1,
    minY: -1,
    maxX: -1,
    maxY: -1
}

var paths=[]

setTimeout(function () {
    $(init)
}, 500)


function init() {
    //由于使用的是百分比布局，画布占据宽度的92%，因此需要在js中进行计算
    CANVAS_WIDTH = ($(window).width()) * 92 / 100;
    CANVAS_HEIGHT = $(window).height();
    var canvas = document.getElementById('myCanvas');
    mCanvasWidth = CANVAS_WIDTH;
    mCanvasHeight = CANVAS_HEIGHT;
    canvas.height = CANVAS_HEIGHT;
    canvas.width = CANVAS_WIDTH;
    context = canvas.getContext('2d');
    var image = new Image();

    if (image.src != "data:image/png;base64,null") {
        preImage(image.src, function () {
            context.drawImage(this, 0, 0, this.width * scale, this.height * scale);
            HAS_IMAGE = true;
        });
    }

    context.lineWidth = mPanWidth;
    context.fillStyle = '#000000';
    context.strokeStyle = '#000000';
    context.lineCap = 'round';
    context.lineJoin = 'miter';

    canvas.addEventListener('touchmove', touchMove, false);
    canvas.addEventListener('touchstart', touchStart, false);
    canvas.addEventListener('touchend', touchEnd, false);

    $('#refresh').click(function () {
        //以下两行为测试代码
        $(canvas).animate({opacity: 0}, 500, function () {
            context.clearRect(0, 0, CANVAS_WIDTH, CANVAS_HEIGHT);
            $(canvas).css('opacity', 1);
        });

//        $('#saved').animate({opacity: 0}, 500, function () {
//            $(this).remove();
//        });
        HAS_IMAGE = false;
        initEffectivePoint();
        return false;
    });

    $('#save').click(function () {
        var canvas = document.getElementById('myCanvas');
        var image = new Image();
        // var imgSrc = canvas.toDataURL("image/png");

        image.src = canvas.toDataURL("image/png");
        //window.postMessage(imgSrc);
        //$("#signImg").attr("src",imgSrc);
        //document.getElementById('signImg').style.transform = 'rotate(-90deg)';
        // imgSrc+=","+HAS_IMAGE

        if (HAS_IMAGE) {
            // window.postMessage(imgSrc);

            getEffectiveAreaImage(image, function (img) {
//                window.postMessage(img);
                //将图片提交给原生模块
                savePictureToNative(img);

                initEffectivePoint();
            })
        } else {
            /**
             * 点击保存签章判断，画布是否有内容
             * 如果画布为空，参数为null
             * */
            var agu = "null"
            window.postMessage(agu);

        }
    });
    $('#setBlack').click(function () {
        mPanWidth = 3;
        removeSelectPenStyle()
        $('#setBlack').addClass("on")

    });

    $('#setRed').click(function () {
        mPanWidth = 5
        removeSelectPenStyle()
        $('#setRed').addClass("on")
    });
    $("#setMax").click(function () {
        mPanWidth = 8
        removeSelectPenStyle()
        $('#setMax').addClass("on")
    });

    function preImage(url, callback) {
        var img = new Image(); //创建一个Image对象，实现图片的预下载
        img.src = url;

        if ((url.indexOf("null") <= 0) && (url.length > 50)) //判断图片非空
        {
            if (img.complete) {
                //如果图片已经存在于浏览器缓存，直接调用回调函数
                callback.call(img);
                return; // 直接返回，不用再处理onload事件
            }

            img.onload = function () { //图片下载完毕时异步调用callback函数。
                callback.call(img);//将回调函数的this替换为Image对象
            };
        }
    }

    setInterval(draw, 20);
}

function removeSelectPenStyle() {
    $('#setBlack').removeClass("on");
    $('#setRed').removeClass("on")
    $('#setMax').removeClass("on")

}

function clean() {
    document.getElementById("refresh").click();

}

// function touchStart(event) {
//     event.preventDefault();
//     HAS_IMAGE = true;
//     mStartPoint = {
//         x: event.touches[0].pageX,
//         y: event.touches[0].pageY,
//     }
//     mEndPoint = {
//         x: event.touches[0].pageX,
//         y: event.touches[0].pageY,
//     }
//     checkEffectivePoint(event.touches[0].pageX - mCanvasOffsetLeft, event.touches[0].pageY - mCanvasOffsetTop)
// }
//
// function touchEnd(event) {
//     event.preventDefault();
// }
//
// function touchMove(event) {
//     event.preventDefault();
//     mEndPoint = {
//         x: event.touches[0].pageX,
//         y: event.touches[0].pageY,
//     }
//     checkEffectivePoint(event.touches[0].pageX - mCanvasOffsetLeft, event.touches[0].pageY - mCanvasOffsetTop)
//     drawLine(mStartPoint, mEndPoint)
// }



function drawLine(startPoint, endPoint) {
    context.lineWidth = mPanWidth;
    context.beginPath();
    context.moveTo(startPoint.x, startPoint.y);
    context.lineTo(endPoint.x, endPoint.y);
    context.stroke();
    context.closePath();
    mStartPoint = endPoint
}

function touchStart(event) {
    event.preventDefault();
    HAS_IMAGE = true;
    for (var i = 0; i < event.touches.length; i++) {
        checkEffectivePoint(event.touches[i].pageX - mCanvasOffsetLeft, event.touches[i].pageY - mCanvasOffsetTop)
        paths.push({
            id: event.touches[i].identifier,
            points: [{
                x: event.touches[i].pageX - mCanvasOffsetLeft,
                y: event.touches[i].pageY - mCanvasOffsetTop,
                timestamp: new Date().getTime(),
                drawn: false
            }],
            complete: false
        });
    }
}

function touchEnd(event) {
    event.preventDefault();
    for (var i = 0; i < event.changedTouches.length; i++) {
        for (var j = 0; j < paths.length; j++) {
            if (paths[j].id == event.changedTouches[i].identifier) {
                paths[j].id = null;
                paths[j].complete = true;
            }
        }
    }
}

function touchMove(event) {
    event.preventDefault();

    for (var i = 0; i < event.touches.length; i++) {
        for (var j = 0; j < paths.length; j++) {
            if (paths[j].id == event.touches[i].identifier) {
                checkEffectivePoint(event.touches[i].pageX - mCanvasOffsetLeft, event.touches[i].pageY - mCanvasOffsetTop)
                paths[j].points.push({
                    x: event.touches[i].pageX - mCanvasOffsetLeft,
                    y: event.touches[i].pageY - mCanvasOffsetTop,
                    drawn: false,
                    timestamp: new Date().getTime()
                });
            }
        }
    }
}

function draw(){
    var DRAW_TIME_THRESHOLD = 10;
    var start = new Date();

    context.lineWidth = mPanWidth
    for (var i = 0; i < paths.length
    && new Date() - start < DRAW_TIME_THRESHOLD; i++) {
        var firstPoint = true;
        var points = paths[i].points;

        if (points.length > 1 && points[points.length - 1].drawn == false) {

            context.beginPath();

            for (var j = 1; j < points.length; j++) {
                if (firstPoint && points[j].drawn == false) {
                    firstPoint = false;

                    context.moveTo(points[j - 1].x, points[j - 1].y);
                    points[j - 1].drawn = true;

                    context.lineTo(points[j].x, points[j].y);
                }
                else if (points[j].drawn == false) {
                    context.lineTo(points[j].x, points[j].y);
                }
                points[j].drawn = true;
            }

            context.stroke();
            context.closePath();
        } else if (paths[i].complete && points[0].drawn == false) {
            context.arc(points[0].x, points[0].y, context.lineWidth / 2, 0,
                Math.PI * 2, false);
            context.closePath();
            context.fill();

            points[0].drawn = true;
        }
    }
}

/**
 * 重新计算手写签名的有效区域
 * @param x
 * @param y
 */
function checkEffectivePoint(x, y) {
    if (x >= 0 && x <= mCanvasWidth) {
        if (x - mPanWidth < mEffectivePoint.minX || mEffectivePoint.minX === -1) {
            mEffectivePoint.minX = x - mPanWidth
            if (mEffectivePoint.minX < 0) {
                mEffectivePoint.minX = 0
            }
        }
        if (x + mPanWidth > mEffectivePoint.maxX || mEffectivePoint.maxX === -1) {
            mEffectivePoint.maxX = x + mPanWidth
            if (mEffectivePoint.maxX > mCanvasWidth) {
                mEffectivePoint.maxX = mCanvasWidth
            }
        }
    }
    if (y >= 0 && y <= mCanvasHeight) {
        if (y - mPanWidth < mEffectivePoint.minY || mEffectivePoint.minY === -1) {
            mEffectivePoint.minY = y - mPanWidth
            if (mEffectivePoint.minY < 0) {
                mEffectivePoint.minY = 0
            }
        }
        if (y + mPanWidth > mEffectivePoint.maxY || mEffectivePoint.maxY === -1) {
            mEffectivePoint.maxY = y + mPanWidth
            if (mEffectivePoint.maxY > mCanvasHeight) {
                mEffectivePoint.maxY = mCanvasHeight
            }
        }
    }
}

function getEffectiveAreaImage(imageSource, callback) {
    var effectivePoint = {
        minX: mEffectivePoint.minX,
        maxX: mEffectivePoint.maxX === mEffectivePoint.minX ? mEffectivePoint.minX + 10 : mEffectivePoint.maxX,
        minY: mEffectivePoint.minY,
        maxY: mEffectivePoint.maxY === mEffectivePoint.minX ? mEffectivePoint.maxY + 10 : mEffectivePoint.maxY
    }
    canvas2 = document.getElementById('idStampAdjustCanvas');
    context2 = canvas2.getContext('2d');
    //先清除
    context2.clearRect(0, 0, canvas2.width, canvas2.height);
    var width = effectivePoint.maxX - effectivePoint.minX
    var height = effectivePoint.maxY - effectivePoint.minY

    // canvas2.width = width
    // canvas2.height = height
    canvas2.width = width
    canvas2.height = height
    loadImage(imageSource.src, function () {
        context2 = canvas2.getContext("2d");
        // context2.rotate(270*Math.PI/180);
        // context2.translate(0-canvas2.height,0);

        context2.drawImage(imageSource,
            effectivePoint.minX, effectivePoint.minY, width, height,
            0, 0,
            width, height)

        callback(canvas2.toDataURL("image/png"));
        // context2.rotate(90*Math.PI/180);
    });
}


function loadImage(url, callback) {
    var img = new Image(); // 创建一个Image对象，实现图片的预下载
    img.src = url;


    if (img.complete) {
        // 如果图片已经存在于浏览器缓存，直接调用回调函数
        callback.call(img);
    }

    img.onload = function () { // 图片下载完毕时异步调用callback函数。
        callback.call(img);// 将回调函数的this替换为Image对象
    }
}


function initEffectivePoint() {
    mEffectivePoint = {
        minX: -1,
        minY: -1,
        maxX: -1,
        maxY: -1
    }
}


/**
 * 将手写绘画的图片base64提交给原生代码
 * @param image  手写绘画图片的base64
 */
function savePictureToNative(image){
    var length = "data:image/png;base64,".length

    var imageBase64 = image.substring(length)
    if(isAndroid){
        window.android.savePicture(imageBase64);
    }else{
        window.webkit.messageHandlers.savePicture.postMessage(imageBase64);
    }
}

function getDeviceType() {

    if (uAgent.indexOf('Android') > -1 || uAgent.indexOf('Linux') > -1) {
        return "android"
    }
    if (uAgent.indexOf('iPhone') > -1 || uAgent.indexOf('iPad') > -1) {
        return 'ios'
    }
    return "other";
}

/**
 *  把判断设备类型单独提出来，是的代码结构清晰
 */
function isAndroid() {
    return getDeviceType() === "android";
}

